#from collections import namedtuple
# TODO: Allow storing data along with the keyword

def append_or_insert(dict_, key, value):
    if key in dict_ or dict_[key]:
        dict_[key].append(value)
    else:
        dict_[key] = [value]

def remove_or_delete(dict_, key, value):
    if value in dict_[key] and len(dict_[key]) == 1:
        del dict_[key]
    else:
        dict_[key].remove(value)

class SubscriptionManager:
    def __init__(self):
        self._subscriptions = {} # Module -> JID -> Keywords

    def get_subscriptions_for(self, module, jid):
        if not module in self._subscriptions:
            return None
        if not jid in self._subscriptions[module]:
            return None

        return self._subscriptions[module][jid]

    def is_subscribed_to(self, module, jid, keyword):
        return keyword in self.get_subscriptions_for(module, jid)

    def __flush(self):
        # TODO
        pass

    def add_subscription_for(self, module, jid, keyword):
        append_or_insert(self._subscriptions[module], jid, keyword)

    def remove_subscription_for(self, module, jid, keyword):
        remove_or_delete(self._subscriptions[module], jid, keyword)
